function block = cfun_inferenz(block,flag)
  // Funktion für die SUM-PROD-Inferenz
  // Eingänge: Fuzzyvektoren E1, E2
  // Ausgang: Fuzzyvektor A
  // Parameter: Regelmatrix M
  
  if flag == 1 then           // Output
    M = block.opar(1);             // Regelmatrix
    N = max(max(M));               // Größe des Ausgangsvektors
    E1 = block.inptr(1);           // Fuzzyvektor E1
    E2 = block.inptr(2);          // Fuzzyvektor E2

    A = zeros(N,1);
    I = 1;
    for I = 1:N
      M0 = double(M == I);
      A(I) = E1'*(M0*E2);
    end
 
    block.outptr(1) = A;
  end
 endfunction
 